<?php 

class 	Chat_Component_Controller_Admincp_Index extends Phpfox_Component
{
	public function process()
	{
		$aSettings = Phpfox::getService('chat') -> getSettings();
		
		$serverhost = $aSettings['server_host'];
		$serverhost = str_replace('http://','',$serverhost);
		$serverhost = str_replace('/','',$serverhost);

		$c_loc = 1;
		$s_own_loc = Phpfox::getService('chat') -> validate_server($serverhost, $aSettings['server_port']);
		if ($s_own_loc == 0)
		{
			$c_own_loc = Phpfox::getService('chat') -> validate_client('http://' . $serverhost . ':' . $aSettings['server_http_port'] . '/');
			if ($c_own_loc == 0)
			{
				$c_loc = 0;
			}
		}
		if ($this->request()->get('chat_status') == '1' || $this->request()->get('chat_status') == '0')
		{
			$aSettings['server_mode'] = $this->request()->get('server_mode');
			if ($aSettings['server_mode'] == '0')
			{
				if ($c_loc == 1)
				{
					if ($this->request()->get('server_host') != '')
					{
						$aSettings['server_host'] = $this->request()->get('server_host');
					}
					else
					{
						$aSettings['server_host'] = $_SERVER['SERVER_NAME'];
					}

					if ($this->request()->get('server_port') != '')
					{
						$aSettings['server_port'] = $this->request()->get('server_port');
					}
					else
					{
						$aSettings['server_port'] = '51127';
					}

					if ($this->request()->get('server_http_port') != '')
					{
						$aSettings['server_http_port'] = $this->request()->get('server_http_port');
					}
					else
					{
						$aSettings['server_http_port'] = '35555';
					}
					
					$server_host = $aSettings['server_host'];
					$server_host = str_replace('http://','',$server_host);
					$server_host = str_replace('/','',$server_host);
					
					$loc = 2;
					$s_own = Phpfox::getService('chat') -> validate_server($server_host, $aSettings['server_port']);
					if ($s_own == 0)
					{
						$c_own = Phpfox::getService('chat') -> validate_client('http://' . $server_host . ':' . $aSettings['server_http_port'] . '/');
						if ($c_own == 0)
						{
							$loc = 0;
							$c_loc = 0;
						}
					}
				}
				else
				{
					$aSettings['server_host'] = $_SERVER['SERVER_NAME'];
					$loc = 0;
				}
			}
			elseif ($aSettings['server_mode'] == '1')
			{
				$aSettings['client_location'] = $this->request()->get('client_location');
				$url = $aSettings['client_location'];
				$url = 'http://'.str_replace('http://','',$url);

				if(substr($url,-1,1) != "/")
				{
					$url .= '/';
				}
				$temp = $url;
//				$this->serverPath = substr($temp, 0, stripos($temp, '.com') + 5);

				if ($urlinfo = Phpfox::getService('chat')->getHostParameters($url))
				{
					$loc = 0;
				}
				else
				{
					$loc = 1;
				}
			}
			else
			{
				if ($this->request()->get('room_name') != '')
				{
					$aSettings['room_name'] = $this->request()->get('room_name');
				}
				else
				{
					$aSettings['room_name'] = $_SERVER['HTTP_HOST'];
				}
				$loc = 0;
			}
			
			$aSettings['chat_status'] = $this->request()->get('chat_status');
			$aSettings['room_list'] = $this->request()->get('room_list');
			$aSettings['user_list'] = $this->request()->get('user_list');
			$aSettings['client_mode'] = $this->request()->get('client_mode');
			$aSettings['present_mode'] = $this->request()->get('present_mode');
			$aSettings['full_screen'] = $this->request()->get('full_screen');
			$aSettings['language'] = $this->request()->get('language');
			$aSettings['skin'] = $this->request()->get('skin');
			
			if ($this->request()->get('client_flash_width') != '')
			{
				$aSettings['client_flash_width'] = $this->request()->get('client_flash_width');
			}
			else
			{
				$aSettings['client_flash_width'] = '779';
			}
			if ($this->request()->get('client_flash_height') != '')
			{
				$aSettings['client_flash_height'] = $this->request()->get('client_flash_height');
			}
			else
			{
				$aSettings['client_flash_height'] = '505';
			}

			if ($this->request()->get('client_html_width') != '')
			{
				$aSettings['client_html_width'] = $this->request()->get('client_html_width');
			}
			else
			{
				$aSettings['client_html_width'] = '634';
			}
			if ($this->request()->get('client_html_height') != '')
			{
				$aSettings['client_html_height'] = $this->request()->get('client_html_height');
			}
			else
			{
				$aSettings['client_html_height'] = '476';
			}

			if ($this->request()->get('client_avatar_width') != '')
			{
				$aSettings['client_avatar_width'] = $this->request()->get('client_avatar_width');
			}
			else
			{
				$aSettings['client_avatar_width'] = '800';
			}
			if ($this->request()->get('client_avatar_height') != '')
			{
				$aSettings['client_avatar_height'] = $this->request()->get('client_avatar_height');
			}
			else
			{
				$aSettings['client_avatar_height'] = '600';
			}
			
			if ($loc == 0)
			{
				if (Phpfox::getService('chat.process')->updateSettings($aSettings))
				{
					$this->url()->send('admincp.chat', null, 'Settings edited successfully');
				}
				else
				{
					$this->url()->send('admincp.chat', null, 'Settings edited failure ');
				}
			}
			else
			{
				if ($loc == 1)
				{
					$this->url()->send('admincp.chat', null, 'Client Location is configured incorrectly');
				}
				elseif ($loc == 2)
				{
					$this->url()->send('admincp.chat', null, 'Chat Server host, port or http_port is configured incorrectly');
				}
			}
		}
		$login_chat = 'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
		$server_name = str_replace('index.php', 'module/chat/static/image/', $login_chat);
		$login_chat = str_replace('index.php','login_chat.php?username=%username%&password=%password%',$login_chat);
		$fc_download_url = 'http://www.123flashchat.com/download-now.html?p=123flashchat.' . ((PATH_SEPARATOR==':') ? (stristr(PHP_OS, 'darwin') ?  'dmg' : 'sh') : 'exe');
		$this->template()->assign(array(
						'settings' => Phpfox::getService('chat')->getSettings(),
						'login_chat' => $login_chat,
						'c_loc' => $c_loc,
						'download' => $fc_download_url,
						'server_name' => $server_name
					)
				);
		
	}
}

?>
