<?php 

class Chat_Service_Process extends Phpfox_Service
{
	public function updateSettings($aSettings)
	{
		$sTable = Phpfox::getT('chat_settings');
		$bResult = true;
		$bUpdate = $this->database()->update($sTable, array(
				'server_mode' => $aSettings['server_mode'],
				'server_host' => $aSettings['server_host'],
				'server_port' => $aSettings['server_port'],
				'server_http_port' => $aSettings['server_http_port'],
				'client_location' => $aSettings['client_location'],
				'client_location' => $aSettings['client_location'],
				'room_name' => $aSettings['room_name'],
				'chat_status' => $aSettings['chat_status'],
				'room_list' => $aSettings['room_list'],
				'user_list' => $aSettings['user_list'],
				'client_mode' => $aSettings['client_mode'],
				'present_mode' => $aSettings['present_mode'],
				'full_screen' => $aSettings['full_screen'],
				'language' => $aSettings['language'],
				'skin' => $aSettings['skin'],
				'client_flash_width' => $aSettings['client_flash_width'],
				'client_flash_height' => $aSettings['client_flash_height'],
				'client_html_width' => $aSettings['client_html_width'],
				'client_html_height' => $aSettings['client_html_height'],
				'client_avatar_width' => $aSettings['client_avatar_width'],
				'client_avatar_height' => $aSettings['client_avatar_height']
		), 'id = 1');
		$bResult = $bResult && $bUpdate;
		$this->renewCache();
		return $bResult;
	}
	
	public function renewCache()
	{
		$this->cache()->remove('chat_settings');
		// reset the cache
		$this->cache()->set('chat_settings');
		$this->cache()->save('chat_settings', Phpfox::getService('chat')->getSettings());
	}
}

?>