<?php

class Chat_Component_Controller_Chatroom extends Phpfox_Component
{
	public function process()
	{
		$oServiceFlashchat = Phpfox::getService('chat');
        $aSettings = $oServiceFlashchat->getSettings();
        $swfurl = $oServiceFlashchat->getClientUrl();
		if ($aSettings['present_mode'] == 1)
		{
			$this->template()->setTemplate('blank');
		}

		$url = $oServiceFlashchat->getClientUrl();
		if ($roomId = $this->request()->get('id'))
		{
			$url .= '&init_room=' . $roomId;
		}

		$this->template()->assign(array(
			'swfurl' => $url,
			'aSettings' => $aSettings,
			)
		);
		$this->template()->assign(array('bUseFullSite' => true));
	}
}

?>