<?php

define('PHPFOX', true);
define('PHPFOX_DS', DIRECTORY_SEPARATOR);
define('PHPFOX_DIR', dirname(__FILE__) . PHPFOX_DS);
if (!function_exists('json_decode'))
{
	require (PHPFOX_DIR . 'module' . PHPFOX_DS . 'chat' . PHPFOX_DS . 'include' . PHPFOX_DS . 'service' . PHPFOX_DS . 'JSON.php');
}

class Chat_Service_Chat extends Phpfox_Service
{
	private $clientUrl = 'http://www.123flashchat.com';
	private $clientSize = array();
	private $serverPath = '';
	private $group = 'dafault';
	private $roomName = 'Lobby';
	
   	function validate_server($host, $port)
    {
    	$s_own_loc = 1;
        $apiCommand = '<Init/>';
        $resultDoc = "";
        $fp = @fsockopen($host, $port, $errno, $errstr, 2);
        if($fp)
        {
            fputs($fp,$apiCommand."\0");
            stream_set_timeout($fp,5);
            while (!feof($fp))
            {
                $resultDoc .= fgets($fp, 1024);
                $resultDoc = rtrim($resultDoc);
            }
            $parser = xml_parser_create("UTF-8");
            xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
            xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
            if (xml_parse_into_struct($parser, $resultDoc, $values, $tags))
            {
                if($values)
                {
                    $s_own_loc = 0;
                }
                xml_parser_free($parser);
                fclose($fp);
            }
        }
        return $s_own_loc;
    }
    function validate_client($client_loc)
    {
    	$c_own_loc = 1;
		$swf = $client_loc . '123flashchat.swf';
		$url = parse_url($swf);
		if($fp = @fsockopen($url['host'], $url['port'], $errno, $errstr, 2))
		{
			fputs($fp,"GET ".(empty($url['path'])?'/':$url['path'])." HTTP/1.1\r\n");
			fputs($fp,"Host:$url[host]\r\n\r\n");
			
			while(!feof($fp))
			{
				$tmp = fgets($fp);
				if(trim($tmp) == '')
				{
					break;
				}
				else if(preg_match_all('|HTTP(.*)|U',$tmp,$arr))
				{
					if (substr($tmp, 9, 3) == '200')
					{
						$c_own_loc=0;
					}
				}
			}
		}
        return $c_own_loc;
    }
	
	public function getSettings()
	{
		$sCacheId = $this->cache()->set('chat_settings');
		
		if (!($aRow = $this->cache()->get($sCacheId)))
		{
			$sTable = Phpfox::getT('chat_settings');
			$aRows = $this->database()->select('*')
				->from($sTable)
				->where('id = 1')
				->execute('getRows');
			$aRow = $aRows[0];
			$this->cache()->save($sCacheId, $aRow);
		}
		return $aRow;
	}
	
	public function Chat_Service_Chat()
	{
	}

	public function getClientUrl()
	{
		$aSettings = $this->getSettings();
		$url = 'http;//www.123flashchat.com/';
		if ($aSettings['server_mode'] == 0)
		{
//			$server_host = '';
//			if ($aSettings['c_loc'] == 1)
//			{
				$server_host = $aSettings['server_host'];
				$server_host = str_replace('http://','',$server_host);
				$server_host = str_replace('/','',$server_host);
				$url = 'http://' . $server_host;
				$url .= ':' . $aSettings['server_http_port'] . '/';
//			}
/*			else
			{
				$server_host = '127.0.0.1';
				$url = 'http://127.0.0.1:35555/';
			}
			*/
			$this->serverPath = $url;
			switch ($aSettings['client_mode'])
			{
				case 0:
					$url .= '123flashchat.swf?';
					break;
				case 1:
					$url .= 'htmlchat/123flashchat.html?';
					break;
				case 2:
					$url .= 'avatarchat.swf?';
					break;
			}
			if ($server_host != '')
			{
				$url .= 'init_host=' . $server_host;
			}
			if ( $aSettings['server_port'] != '')
			{
				$url .= '&init_port=' . $aSettings['server_port'];		
			}

			$url .= '&init_skin=' . $aSettings['skin'];
			if ($aSettings['language'] != '*')
			{
				$url .= '&init_lang=' . $aSettings['language'];
			}
			if(Phpfox::isUser() && $user = $this->getUser())
			{
				$url .= '&init_user=' . $user['user_name'] . '&init_password=' . $user['password'];
			}
		}
		else if ($aSettings['server_mode'] == 1)
		{
			$url = $aSettings['client_location'];
			$url = 'http://'.str_replace('http://','',$url);

			if(substr($url,-1,1) != "/")
			{
				$url .= '/';
			}
			$temp = $url;
			$this->serverPath = substr($temp, 0, stripos($temp, '.com') + 5);

			$urlinfo = $this->getHostParameters($url);
			parse_str($urlinfo['query']);
			
			switch ($aSettings['client_mode'])
			{
				case 0:
					$url .= '123flashchat.swf?';
					break;
				case 1:
					$url .= 'htmlchat/123flashchat.html?';
					break;
				case 2:
					$url .= 'avatarchat.swf?';
					break;
			}
			
			if(!empty($init_host))
			{
				$url .= 'init_host=' . $init_host;
			}
			if(!empty($init_port))
			{
				$url .= '&init_port=' . $init_port;
			}
			if(!empty($init_group))
			{
				$url .= '&init_group=' . $init_group;
				$this->group = $init_group;
			}
			
			$url .= '&init_skin=' . $aSettings['skin'];
			
			if ($aSettings['language'] != '*')
			{
				$url .= '&init_lang=' . $aSettings['language'];
			}
			if(Phpfox::isUser() && $user = $this->getUser())
			{
				$url .= '&init_user=' . $user['user_name'] . '&init_password=' . $user['password'];
			}
		}
		else
		{
			$url = 'http://free.123flashchat.com/js.php?';
			$this->serverPath = $url;
			$this->roomName = $aSettings['room_name'];
			$url .= 'room=' . $aSettings['room_name'];
			$url .= '&skin=' . $aSettings['skin'];
			if ($aSettings['language'] != '*')
			{
				$url .= '&lang=' . $aSettings['language'];
			}
			$url .= '&width=' . $aSettings['client_flash_width'];
			$url .= '&height=' . $aSettings['client_flash_height'];
			if (Phpfox::isUser())
			{
				$url .= '&user=' . Phpfox::getUserBy('user_name');
			}
		}
		
		return $url;
	}
	
	function getHostParameters($client_location)
	{
		$content = @file_get_contents($client_location);
		if(!empty($content))
		{
			$pattern = '|var urlValue="(.*)"|U';
			preg_match($pattern, $content, $matches);
			if(!empty($matches[1]))
			{
				$url = $matches[1];
				$urlinfo = parse_url($url);
				return $urlinfo;
			}
			else
			{
				$pattern = '|PARAM NAME=movie VALUE="(.*)"|U';
				preg_match($pattern, $content, $matches);
				if(!empty($matches[1]))
				{
					$url = $matches[1];
					$urlinfo = parse_url($url);
					return $urlinfo;
				}
			}
			return false;
		}
	}
	
	public function getUser()
	{
		$user = array();
		if (Phpfox::isUser())
		{
			$u = Phpfox::getLib('phpfox.database')
					->select('*')
					->from(Phpfox::getT('user'))
					->where('user_id = ' . Phpfox::getUserId())
					->execute('getRows');
			$user = $u[0];
		}
		return $user;
	}
	
public function getRooms()
{
	if (function_exists('json_decode'))
	{
		$sCachedId = $this->cache()->set('chat_rooms');	
		if (!($rooms_json = $this->cache()->get($sCachedId, 2)))
		{
			$aSettings = $this->getSettings();
		    switch ($aSettings['server_mode'])
    	    {
				case 0:
      		  	    $room_js = $this->serverPath . 'rooms.js';
       		 	    if($rs = @file_get_contents($room_js))
					{
						$rooms_json = substr($rs,10,-1);
					}
        	    	break;
				case 1:
					$room_js = $this->serverPath . "rooms.js?group=" . $this->group;
					if($rs = @file_get_contents($room_js))
					{
						$rooms_json = substr($rs,10,-1);
					}
					break;
				case 2:
            	break;
			}
			$this->cache()->save($sCachedId, $rooms_json);
		}
        return json_decode($rooms_json, true);	
	}
	else
	{
		$srvr = new Services_JSON();
		$sCachedId = $this->cache()->set('chat_rooms');	
		if (!($rooms_json = $this->cache()->get($sCachedId, 2)))
		{
			$aSettings = $this->getSettings();
		    switch ($aSettings['server_mode'])
    	    {
				case 0:
      		  	    $room_js = $this->serverPath . 'rooms.js';
       		 	    if($rs = @file_get_contents($room_js))
					{
						$rooms_json = substr($rs,10,-1);
					}
        	    	break;
				case 1:
					$room_js = $this->serverPath . "rooms.js?group=" . $this->group;
					if($rs = @file_get_contents($room_js))
					{
						$rooms_json = substr($rs,10,-1);
					}
					break;
				case 2:
            		break;
			}
			$this->cache()->save($sCachedId, $rooms_json);
		}
		$temp = $srvr -> decode($rooms_json);
		$what = array();
		foreach ($temp as $nani)
		{
			array_push($what, get_object_vars($nani));	
		}
		return $what;
	}
}

public function getUsers()
{
	if (function_exists('json_decode'))
	{
		$sCachedId = $this->cache()->set('chat_users');	
		if (!($users_json = $this->cache()->get($sCachedId, 2)))
		{
			$aSettings = $this->getSettings();
			switch ($aSettings['server_mode'])
        	{
            	case 0:
                	$users = array();
                	$rooms = $this->getRooms();
                	foreach ($rooms as $room)
                	{
                    	$user_js = $this->serverPath . "roomonlineusers.js?roomid=" . $room['id'];
                    	if($rs = @file_get_contents($user_js))
                    	{
							$users = array_merge($users, json_decode(substr($rs,20,-1),true));
                    	}
                	}
                	$users_json = json_encode($users);
        			break;
            	case 1:
        	    	$user_js = $this->serverPath . "roomonlineusers.js?group=" . $this->group;
        	    	if($rs = @file_get_contents($user_js))
        	    	{
        	        	$users_json = substr($rs,20,-1);
        	    	}
        	    	break;
        		case 2:
        	    	$user_js = "http://free.123flashchat.com/freeroomuser.php?roomname=" . $this->roomName;
        	    	if($rs = @file_get_contents($user_js))
    	        	{
    	            	foreach (explode(',', substr($rs,24,-3)) as $user)
    	            	{
							$users[] = array('name' => $user);
    	            	}
    	        	}
    	        	$users_json = json_encode($users);
    	        	break;
        	}
        	$this->cache()->save($sCachedId, $users_json);
		}
		return json_decode($users_json, true);
	}
	else
	{
		$srvr = new Services_JSON();
		$sCachedId = $this->cache()->set('chat_users');	
		if (!($users_json = $this->cache()->get($sCachedId, 2)))
		{
			$aSettings = $this->getSettings();
			switch ($aSettings['server_mode'])
        	{
            	case 0:
                	$users = array();
                	$rooms = $this->getRooms();
                	foreach ($rooms as $room)
                	{
                    	$user_js = $this->serverPath . "roomonlineusers.js?roomid=" . $room['id'];
                    	if($rs = @file_get_contents($user_js))
                    	{
							$users = array_merge($users, $srvr -> decode(substr($rs,20,-1),true));
                    	}
                	}
                	$users_json = $srvr -> encode($users);
        	    	break;
            	case 1:
        	    	$user_js = $this->serverPath . "roomonlineusers.js?group=" . $this->group;
        	    	if($rs = @file_get_contents($user_js))
        	    	{
        	        	$users_json = substr($rs,20,-1);
        	    	}
        	    	break;
        		case 2:
        	    	$user_js = "http://free.123flashchat.com/freeroomuser.php?roomname=" . $this->roomName;
        	    	if($rs = @file_get_contents($user_js))
    	        	{
    	        		foreach (explode(',', substr($rs,24,-3)) as $user)
    	            	{
							$users[] = array('name' => $user);
    	            	}
    	        	}
    	        	$users_json = $srvr -> encode($users);
    	        	break;
			}
			$this->cache()->save($sCachedId, $users_json);
		}
		$temp = $srvr -> decode($users_json);
		$what = array();
		foreach ($temp as $nani)
		{
			array_push($what, get_object_vars($nani));	
		}
		return $what;
	}
}

public function getStatus()
{
	if (function_exists('json_decode'))
	{
		$sCachedId = $this->cache()->set('chat_status');	
		if (!($status_json = $this->cache()->get($sCachedId, 2)))
		{
		
			$aSettings = $this->getSettings();
			switch ($aSettings['server_mode'])
			{
				case 0:
        		    $status_js = $this->serverPath . 'online.js';
        	    	if($rs = @file_get_contents($status_js))
					{
						$status_json = substr($rs,11,-1);
					}
        	    	break;
        		case 1:
					$status_js = $this->serverPath . 'online.js?group=' . $this->group;
        	    	if($rs = @file_get_contents($status_js))
        	    	{
						$status_json = substr($rs,11,-1);
        	    	}
        	    	break;
        		case 2:
        	    	$status_js = 'http://free.123flashchat.com/freeroomnum.php?roomname=' . $this->roomName;
        	    	if($rs = @file_get_contents($status_js))
        	    	{
        	    		$status['rn'] = 'only this';
        	    		$status['cn'] = 'unknow';
						$status['ln'] = substr($rs,24,-3);
						$status_json = json_encode($status);
        	    	}
        	    	break;
        	}
        	$this->cache()->save($sCachedId, $status_json);
		}
    	return json_decode($status_json,true);
	}
	else
	{
		$sCachedId = $this->cache()->set('chat_status');	
		if (!($status_json = $this->cache()->get($sCachedId, 2)))
		{
		
			$aSettings = $this->getSettings();
			switch ($aSettings['server_mode'])
			{
				case 0:
        		    $status_js = $this->serverPath . 'online.js';
        		    if($rs = @file_get_contents($status_js))
					{
						$status_json = substr($rs,11,-1);
					}
        		    break;
        		case 1:
				$status_js = $this->serverPath . 'online.js?group=' . $this->group;
        	    if($rs = @file_get_contents($status_js))
        	    {
					$status_json = substr($rs,11,-1);
        	    }
        	    	break;
        		case 2:
					$status_js = 'http://free.123flashchat.com/freeroomnum.php?roomname=' . $this->roomName;
					if($rs = @file_get_contents($status_js))
					{
						$status['rn'] = 'only this';
						$status['cn'] = 'unknow';
						$status['ln'] = substr($rs,24,-3);
						$status_json = $srvr -> encode($status);
        	    	}
					break;
        	}
        	$this->cache()->save($sCachedId, $status_json);
		}
		$srvr = new Services_JSON();
		$temp = $srvr -> decode($status_json);
		$arr = get_object_vars($temp);
		return $arr;
	}
}

}
?>